;

DrawSights              LD DE,(XTurnRatio)              ;
                        LD HL,(YDiveRatio)              ;
                        SRA H                           ;
                        RR L                            ;
                        LD A,L                          ;
                        XOR $80                         ;
                        LD L,A                          ;
                        SRA D                           ;
                        RR E                            ;
                        LD A,E                          ;
                        XOR $80                         ;
                        CP $04                          ;
                        JR NC LA097                     ;

                        LD A,$04                        ;
                        JP LA09D                        ;

LA097                   CP $FB                          ;
                        JR C LA09D                      ;

                        LD A,$FB                        ;
LA09D                   LD E,A                          ;
                        LD H,high DivTab                ;
                        LD L,(HL)                       ;
                        DEC L                           ;
                        DEC L                           ;
                        DEC L                           ;
                        LD A,E                          ;
                        SUB $03                         ;
                        RRCA                            ;
                        RRCA                            ;
                        RRCA                            ;
                        AND $1F                         ;
                        LD D,A                          ;
                        LD A,E                          ;
                        SUB $03                         ;
                        AND $07                         ;
                        ADD A,A                         ;
                        ADD A,A                         ;
                        ADD A,A                         ;
                        ADD A,A                         ;
                        LD C,A                          ;
                        LD B,0                          ;
                        LD IX,Sights                    ;
                        ADD IX,BC                       ;
                        LD E,L                          ;
                        LD HL,(SighDE)                  ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        LD A,L                          ;
                        OR H                            ;
                        JR NZ PutS2                     ;

                        PUSH IX                         ;
                        POP BC                          ;
                        LD HL,(SighIX)                   ;
                        OR A                            ;
                        SBC HL,BC                       ;
                        LD A,L                          ;
                        OR H                            ;
                        JR Z LA0E8                      ;

PutS2                   PUSH IX                         ;
                        PUSH DE                         ;
                        CALL UnDrawSights               ;
                        POP DE                          ;
                        POP IX                          ;
                        LD (SighDE),DE                  ;
                        LD (SighIX),IX                  ;

LA0E8                   LD B,7                          ;
LA0EA                   LD L,E                          ;
                        LD H,high YTable                ;
                        LD A,(HL)                       ;
                        INC H                           ;
                        LD H,(HL)                       ;
                        ADD A,D                         ;
                        LD L,A                          ;
                        LD A,(IX)                       ;
                        OR (HL)                         ;
                        LD (HL),A                       ;
                        INC IX                          ;
                        INC L                           ;
                        LD A,(IX)                       ;
                        OR (HL)                         ;
                        LD (HL),A                       ;
                        INC E                           ;
                        INC IX                          ;
                        DJNZ LA0EA                      ;

                        RET                             ;

UnDrawSights            LD DE,$0000                     ;
SighDE                  EQU *-2                         ;
                        LD IX,$0000                     ;
SighIX                  EQU *-2                         ;

                        LD B,7                          ;
LA10E                   LD L,E                          ;
                        LD H,high YTable                ;
                        LD A,(HL)                       ;
                        INC H                           ;
                        LD H,(HL)                       ;
                        ADD A,D                         ;
                        LD L,A                          ;
                        LD A,(IX)                       ;
                        CPL                             ;
                        AND (HL)                        ;
                        LD (HL),A                       ;
                        INC IX                          ;
                        INC L                           ;
                        LD A,(IX)                       ;
                        CPL                             ;
                        AND (HL)                        ;
                        LD (HL),A                       ;
                        INC E                           ;
                        INC IX                          ;
                        DJNZ LA10E                      ;

                        RET                             ;

Sights                  DEFB $10,$00,$10,$00,$00,$00,$C6,$00;
                        DEFB $00,$00,$10,$00,$10,$00,$00,$00;
                        DEFB $08,$00,$08,$00,$00,$00,$63,$00;
                        DEFB $00,$00,$08,$00,$08,$00,$00,$00;
                        DEFB $04,$00,$04,$00,$00,$00,$31,$80;
                        DEFB $00,$00,$04,$00,$04,$00,$00,$00;
                        DEFB $02,$00,$02,$00,$00,$00,$18,$C0;
                        DEFB $00,$00,$02,$00,$02,$00,$00,$00;
                        DEFB $01,$00,$01,$00,$00,$00,$0C,$60;
                        DEFB $00,$00,$01,$00,$01,$00,$00,$00;
                        DEFB $00,$80,$00,$80,$00,$00,$06,$30;
                        DEFB $00,$00,$00,$80,$00,$80,$00,$00;
                        DEFB $00,$40,$00,$40,$00,$00,$03,$18;
                        DEFB $00,$00,$00,$40,$00,$40,$00,$00;
                        DEFB $00,$20,$00,$20,$00,$00,$01,$8C;
                        DEFB $00,$00,$00,$20,$00,$20,$00,$00;

CalcAddr                LD BC,128                       ;
                        ADD HL,BC                       ;
                        EX DE,HL                        ;
                        ADD HL,BC                       ;
                        EX DE,HL                        ;
                        LD H,high DivTab                ;
                        LD L,(HL)                       ;
                        LD H,high YTable                ;
                        LD A,(HL)                       ;
                        INC H                           ;
                        LD H,(HL)                       ;
                        LD L,A                          ;
                        LD A,E                          ;
                        RRCA                            ;
                        RRCA                            ;
                        RRCA                            ;
                        AND $1F                         ;
                        OR L                            ;
                        LD L,A                          ;
                        LD A,E                          ;
                        AND $07                         ;
                        LD E,A                          ;
                        LD D,high BitTab                ;
                        LD A,(DE)                       ;
                        RET                             ;

VS1                     POP HL                          ;
                        SCF                             ;
                        RET                             ;

; Draw a vertical line. I optimised this code so it draws longer lines quickly, at the expense of
; having a longer setup time for shorter lines than could be achieved.
; The question is - why not have two routines and use the one with less set-up time if the line
; is short? A test doesn't take long, after all... Well, it's all to do with how the game feels.
; As towers come towards you and get longer the game would slow down more noticably as they hit
; the threshold and that slow-down felt... clumsy...

; This code always returns with the carry-flag set, it's because it might be the last thing an object
; draw routine calls and the carry-flag means the object is still alive.

VertLine                PUSH HL                         ;
                        OR A                            ;
                        LD HL,128                       ;
                        ADC HL,BC                       ;
                        JP M VS1                        ;

                        INC H                           ;
                        DEC H                           ;
                        JR NZ VS1                       ;

                        LD A,L                          ;
                        RRCA                            ;
                        RRCA                            ;
                        RRCA                            ;
                        AND $1F                         ;
                        LD (LA440),A                    ;

                        LD A,L                          ; Build the BIT instruction for the SMC
                        RLCA                            ;
                        RLCA                            ;
                        RLCA                            ;
                        CPL                             ;
                        AND $38                         ;
                        OR $C6                          ;

                        LD (Vert4+1),A                  ;
                        LD (Vert40+1),A                 ;
                        LD (Vert41+1),A                 ;
                        LD (Vert42+1),A                 ;
                        LD (Vert43+1),A                 ;
                        LD (Vert44+1),A                 ;
                        LD (Vert45+1),A                 ;
                        LD (Vert46+1),A                 ;
                        LD (Vert47+1),A                 ;
                        LD (Vert48+1),A                 ;

                        AND $BF                         ; Make it a CLR instruction?
                        LD (IY+AnyBit),A                ;

                        POP HL                          ;
                        LD BC,128                       ;
                        ADD HL,BC                       ;
                        EX DE,HL                        ;
                        ADD HL,BC                       ;
                        LD A,H                          ;
                        OR A                            ;
                        JR Z VS2                        ;

                        LD L,$00                        ;
                        JP M VS2                        ;

                        LD L,$FF                        ;
VS2                     LD H,high DivTab                ;
                        LD A,D                          ;
                        OR A                            ;
                        JR Z VS3                        ;

                        LD E,$00                        ;
                        JP M VS3                        ;

                        LD E,$FF                        ;
VS3                     LD D,high DivTab                ;
                        LD A,(DE)                       ;
                        SUB (HL)                        ;
                        SCF                             ;
                        RET Z                           ;

                        INC A                           ;
                        LD (IY+AnyB),A                  ;
                        LD B,A                          ;
                        LD L,(HL)                       ;
                        LD H,high YTable                ;
                        LD A,$00                        ;
LA440                   EQU *-1                         ;
                        LD C,A                          ;
                        ADD A,(HL)                      ;
                        LD (IY+AnyL),A                  ;
                        INC H                           ;
                        LD A,(HL)                       ;
                        LD (IY+AnyH),A                  ;
                        LD A,L                          ;
                        RLCA                            ;
                        RLCA                            ;
                        AND $03                         ;
                        OR $58                          ;
                        LD (IY+AnyH1),A                 ;
                        LD D,A                          ;
                        LD A,L                          ;
                        RLCA                            ;
                        RLCA                            ;
                        AND $E0                         ;
                        OR C                            ;
                        LD (IY+AnyL1),A                 ;
                        LD E,A                          ;
                        LD A,L                          ;
                        AND $07                         ;
                        LD L,A                          ;
                        LD H,high BitTab                ;
                        LD A,(Colour)                   ;
                        LD C,A                          ;
                        LD A,(HL)                       ;
                        LD (IY+AnyA),A                  ;
                        EX DE,HL                        ;
                        LD DE,$0020                     ;
                        EXX                             ;
                        LD C,$1F                        ;
                        LD B,(IY+AnyB)                  ;
                        LD L,(IY+AnyL)                  ;
                        LD H,(IY+AnyH)                  ;
                        CALL Vert2                      ;
                        LD (IY+AnypCode),low Vert10     ;
                        LD (IY+AnypCode+1),high Vert10  ;
                        LD BC,lObjeLine                 ;
                        ADD IY,BC                       ;
                        SCF                             ;
                        RET                             ;

Vert2                   DEC B                           ;
                        RET Z                           ;

Vert4                   SET 0,(HL)                      ;
                        INC H                           ;
                        RRCA                            ;
                        JP NC Vert2                     ;

                        LD A,L                          ;
                        ADC A,C                         ;
                        LD L,A                          ;
                        JR C Vert1                      ;

                        LD A,H                          ;
                        SUB $08                         ;
                        LD H,A                          ;
Vert1                   EXX                             ;
                        LD (HL),C                       ;
                        ADD HL,DE                       ;
                        EXX                             ;
                        LD A,B                          ;
                        RRCA                            ;
                        RRCA                            ;
                        RRCA                            ;
                        AND $1F                         ;
                        JR Z LA4E2                      ;

Vert40                  SET 0,(HL)                      ;
                        INC H                           ;
Vert41                  SET 0,(HL)                      ;
                        INC H                           ;
Vert42                  SET 0,(HL)                      ;
                        INC H                           ;
Vert43                  SET 0,(HL)                      ;
                        INC H                           ;
Vert44                  SET 0,(HL)                      ;
                        INC H                           ;
Vert45                  SET 0,(HL)                      ;
                        INC H                           ;
Vert46                  SET 0,(HL)                      ;
                        INC H                           ;
Vert47                  SET 0,(HL)                      ;
                        INC H                           ;
                        EX AF,AF'                       ;
NoiseFlip5              LD A,$00                        ;
                        XOR $F8                         ;
                        LD (NoiseFlip5+1),A             ;
smcNoise5               OUT ($FE),A                     ;

                        LD A,L                          ;
                        ADD A,$20                       ;
                        LD L,A                          ;
                        JR C LA4DA                      ;

                        LD A,H                          ;
                        SUB $08                         ;
                        LD H,A                          ;
LA4DA                   EXX                             ;
                        LD (HL),C                       ;
                        ADD HL,DE                       ;
                        EXX                             ;
                        EX AF,AF'                       ;
                        DEC A                           ;
                        JR NZ Vert40                    ;

LA4E2                   LD A,B                          ;
                        AND $07                         ;
                        RET Z                           ;

                        LD B,A                          ;
Vert48                  SET 0,(HL)                      ;
                        INC H                           ;
                        DJNZ Vert48                     ;

                        EXX                             ;
                        LD (HL),C                       ;
                        EXX                             ;
                        RET                             ;

; Draws a vertical line

Vert10                  LD L,(IY+AnyL1)                 ;
                        LD H,(IY+AnyH1)                 ;
                        LD DE,$0020                     ;
                        LD A,(GameAttr)                 ;
                        LD C,A                          ;
                        EXX                             ;
                        LD A,(IY+AnyBit)                ;
                        LD (Vert4+1),A                  ;
                        LD (Vert40+1),A                 ;
                        LD (Vert41+1),A                 ;
                        LD (Vert42+1),A                 ;
                        LD (Vert43+1),A                 ;
                        LD (Vert44+1),A                 ;
                        LD (Vert45+1),A                 ;
                        LD (Vert46+1),A                 ;
                        LD (Vert47+1),A                 ;
                        LD (Vert48+1),A                 ;
                        LD A,(IY+AnyA)                  ;
                        LD B,(IY+AnyB)                  ;
                        LD L,(IY+AnyL)                  ;
                        LD H,(IY+AnyH)                  ;
                        LD C,$1F                        ;
                        JP Vert2                        ;

HS1                     POP HL                          ;
                        SCF                             ;
                        RET                             ;

HpS                     DEFW $0000                      ;
HpA                     DEFW $0000                      ;

; Draw the ends of a horizontal line - this is used for explosions. A ghasty hack, really.
; Have a bucket handy for when you work out what this code actually does.

ExplosionLine           LD A,$00                        ; NOP
                        LD (Hori1a),A                   ;
                        LD (Hori1b),A                   ;

smcNoise1               OUT ($FE),A                     ;

                        CALL HoriLine                   ;

                        LD A,$71                        ; LD (HL),C
                        LD (Hori1a),A                   ;

                        LD A,$12                        ; LD (DE),A
                        LD (Hori1b),A                   ;

                        LD A,$F8                        ;
smcNoise2               OUT ($FE),A                     ;

                        RET                             ;

; Draw a horizontal line

; This code always returns the carry-flag set, it's because it might be the last thing an object
; draw routine calls and the carry-flag means the object is still alive.

HoriLine                PUSH HL                         ;

                        LD L,C                          ;
                        LD H,B                          ;

                        LD BC,128                       ;
                        ADD HL,BC                       ;

                        INC H                           ;
                        DEC H                           ;
                        JR NZ HS1                       ;

                        LD H,high DivTab                ;
                        LD L,(HL)                       ;

LA561                   LD H,high YTable                ;
                        LD C,(HL)                       ;

                        INC H                           ;
                        LD B,(HL)                       ;
                        LD (HpS),BC                     ;

                        LD (IY+AnyH),B                  ;
                        LD A,L                          ;
                        RLCA                            ;
                        RLCA                            ;
                        AND $03                         ;
                        OR $58                          ;
                        LD H,A                          ;
                        LD A,L                          ;
                        RLCA                            ;
                        RLCA                            ;
                        AND $E0                         ;
                        LD L,A                          ;
                        LD (HpA),HL                     ;
                        LD (IY+AnyD),H                  ;
                        POP HL                          ;
                        LD BC,128                       ;
                        ADD HL,BC                       ;
                        LD A,H                          ;
                        OR A                            ;
                        JR Z HS2                        ;

                        LD L,$00                        ;
                        JP M HS2                        ;

                        LD L,$FF                        ;
HS2                     EX DE,HL                        ;
                        ADD HL,BC                       ;
                        LD A,H                          ;
                        OR A                            ;
                        JR Z HS3                        ;

                        LD L,$00                        ;
                        JP M HS3                        ;

                        LD L,$FF                        ;
HS3                     LD A,L                          ;
                        SUB E                           ;
                        SCF                             ;
                        RET Z                           ;

                        LD A,L                          ;
                        AND $07                         ;
                        ADD A,$08                       ;
                        LD C,A                          ;
                        LD B,high BitTab                ;
                        LD A,(BC)                       ;
                        LD (IY+AnyA),A                  ;
                        LD A,E                          ;
                        AND $07                         ;
                        ADD A,$10                       ;
                        LD C,A                          ;
                        LD A,(BC)                       ;
                        LD (IY+AnyA1),A                 ;
                        LD A,L                          ;
                        RRCA                            ;
                        RRCA                            ;
                        RRCA                            ;
                        AND $1F                         ;
                        LD L,A                          ;
                        LD A,E                          ;
                        RRCA                            ;
                        RRCA                            ;
                        RRCA                            ;
                        AND $1F                         ;
                        LD E,A                          ;
                        LD A,(HpS)                      ;
                        OR L                            ;
                        LD (HpS),A                      ;
                        LD (IY+AnyL),A                  ;
                        LD A,(HpA)                      ;
                        OR L                            ;
                        LD (HpA),A                      ;
                        LD (IY+AnyE),A                  ;
                        LD A,E                          ;
                        SUB L                           ;
                        JR Z HS4                        ;

                        LD (IY+AnyB),A                  ;

                        LD HL,(HpS)                     ;
                        LD DE,(HpA)                     ;
                        LD B,A                          ;
                        LD A,(Colour)                   ;
                        LD C,A                          ;
                        LD A,(IY+AnyA1)                 ;
                        EX AF,AF'                       ;
                        LD A,(IY+AnyA)                  ;
                        CALL HoriS                      ;

                        LD (IY+AnypCode),low HS6        ;
                        LD (IY+AnypCode+1),high HS6     ;

                        LD BC,lObjeLine                 ;
                        ADD IY,BC                       ;
                        SCF                             ;
                        RET                             ;

HS4                     LD HL,(HpA)                     ;
                        LD A,(Colour)                   ;
                        LD (HL),A                       ;
                        LD HL,(HpS)                     ;
                        LD A,(IY+AnyA)                  ;
                        AND (IY+AnyA1)                  ;
                        OR (HL)                         ;
                        LD (HL),A                       ;
                        LD (IY+AnypCode),low HS5        ;
                        LD (IY+AnypCode+1),high HS5     ;
                        LD BC,lObjeLine                 ;
                        ADD IY,BC                       ;
                        SCF                             ;
                        RET                             ;

HS5                     LD L,(IY+AnyE)                  ;
                        LD H,(IY+AnyD)                  ;
                        LD A,(GameAttr)                 ;
                        LD (HL),A                       ;
                        LD L,(IY+AnyL)                  ;
                        LD H,(IY+AnyH)                  ;
                        LD A,(IY+AnyA)                  ;
                        AND (IY+AnyA1)                  ;
                        CPL                             ;
                        AND (HL)                        ;
                        LD (HL),A                       ;
                        RET                             ;

HS6                     LD L,(IY+AnyL)                  ;
                        LD H,(IY+AnyH)                  ;
                        LD E,(IY+AnyE)                  ;
                        LD D,(IY+AnyD)                  ;
                        LD B,(IY+AnyB)                  ;
                        LD A,(IY+AnyA1)                 ;
                        CPL                             ;
                        EX AF,AF'                       ;
                        LD A,(GameAttr)                 ;
                        LD C,A                          ;
                        LD A,(IY+AnyA)                  ;
                        CPL                             ;
                        AND (HL)                        ;
                        LD (HL),A                       ;
                        LD A,C                          ;
                        LD (DE),A                       ;
                        INC L                           ;
                        INC E                           ;
                        DJNZ LA66A                      ;

                        LD (DE),A                       ;
                        EX AF,AF'                       ;
                        AND (HL)                        ;
                        LD (HL),A                       ;
                        RET                             ;

LA66A                   LD C,$00                        ;
LA66C                   LD (HL),C                       ;
                        LD (DE),A                       ;
                        INC L                           ;
                        INC E                           ;
                        DJNZ LA66C                      ;

                        LD (DE),A                       ;
                        EX AF,AF'                       ;
                        AND (HL)                        ;
                        LD (HL),A                       ;
                        RET                             ;

HoriS                   OR (HL)                         ;
                        LD (HL),A                       ;
                        LD A,C                          ;
                        LD (DE),A                       ;
                        INC L                           ;
                        INC E                           ;
                        DJNZ Hori0a                     ;

                        LD (DE),A                       ;
                        EX AF,AF'                       ;
                        OR (HL)                         ;
                        LD (HL),A                       ;
                        RET                             ;

Hori0a                  LD C,$FF                        ;
Hori1a                  LD (HL),C                       ;
Hori1b                  LD (DE),A                       ;
                        INC L                           ;
                        INC E                           ;
                        DJNZ Hori1a                     ;

                        LD (DE),A                       ;
                        EX AF,AF'                       ;
                        OR (HL)                         ;
                        LD (HL),A                       ;
                        RET                             ;

; Part of the clipping routine that decides which bit of a line is visible, if any.

CalcEdges               XOR A                           ;
                        INC H                           ;
                        DEC H                           ;
                        JR Z CalcC1b                    ;

                        BIT 7,H                         ;
                        JR NZ CalcC1a                   ;

                        OR $02                          ;
                        JP CalcC1b                      ;

CalcC1a                 OR $01                          ;
CalcC1b                 INC D                           ;
                        DEC D                           ;
                        RET Z                           ;

                        BIT 7,D                         ;
                        JR NZ CalcC1c                   ;

                        OR $04                          ;
                        RET                             ;

CalcC1c                 OR $08                          ;
                        RET                             ;

; This is evil.

ClipThing               LD BC,128                       ;
                        ADD HL,BC                       ;
                        LD (ctX2),HL                    ;
                        EX DE,HL                        ;
                        ADD HL,BC                       ;
                        LD (ctX1),HL                    ;
                        EXX                             ;
                        LD BC,128                       ;
                        ADD HL,BC                       ;
                        LD (ctY2),HL                    ;
                        EX DE,HL                        ;
                        ADD HL,BC                       ;
                        LD (ctY1),HL                    ;
                        LD HL,$0000                     ;
ctX1                    EQU *-2                         ;
                        LD DE,$0000                     ;
ctY1                    EQU *-2                         ;
                        CALL CalcEdges                  ;
                        LD B,A                          ;
                        LD HL,$0000                     ;
ctX2                    EQU *-2                         ;
                        LD DE,$0000                     ;
ctY2                    EQU *-2                         ;
                        CALL CalcEdges                  ;
                        LD C,A                          ;
                        OR B                            ;
                        RET Z                           ;

                        LD A,C                          ;
                        AND B                           ;
                        SCF                             ;
                        RET NZ                          ;

                        LD HL,(ctX1)                    ;
                        LD (PaX),HL                     ;
                        LD HL,(ctY1)                    ;
                        LD (PaY),HL                     ;
                        LD HL,(ctX2)                    ;
                        LD (PbX),HL                     ;
                        LD HL,(ctY2)                    ;
                        LD (PbY),HL                     ;
                        CALL ClipInner                  ;
                        RET C                           ;

                        LD HL,(PaX)                     ;
                        LD (ctX2),HL                    ;
                        LD HL,(PaY)                     ;
                        LD (ctY2),HL                    ;
                        LD HL,(ctX1)                    ;
                        LD (PbX),HL                     ;
                        LD HL,(ctY1)                    ;
                        LD (PbY),HL                     ;
                        CALL ClipInner                  ;
                        RET C                           ;

                        LD HL,(PaX)                     ;
                        LD (ctX1),HL                    ;
                        LD HL,(PaY)                     ;
                        LD (ctY1),HL                    ;
                        OR A                            ;
                        RET                             ;

ClipInner               LD HL,$0000                     ;
PbX                     EQU *-2                         ;
                        LD DE,$0000                     ;
PbY                     EQU *-2                         ;
                        LD (PmX),HL                     ;
                        LD (PmY),DE                     ;
                        CALL CalcEdges                  ;
                        OR A                            ;
                        JR NZ C2                        ;

                        LD (PaX),HL                     ;
                        LD (PaY),DE                     ;
                        RET                             ;

C2                      LD HL,$0000                     ;
PaX                     EQU *-2                         ;
                        LD DE,$0000                     ;
PaY                     EQU *-2                         ;
                        CALL CalcEdges                  ;
                        LD B,A                          ;
                        LD HL,$0000                     ;
PmX                     EQU *-2                         ;
                        LD DE,$0000                     ;
PmY                     EQU *-2                         ;
                        CALL CalcEdges                  ;
                        AND B                           ;
                        SCF                             ;
                        RET NZ                          ;

                        LD HL,(PmX)                     ;
                        LD DE,(PaX)                     ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        SRA H                           ;
                        RR L                            ;
                        LD DE,(PaX)                     ;
                        ADD HL,DE                       ;
                        LD (PmX),HL                     ;
                        LD HL,(PmY)                     ;
                        LD DE,(PaY)                     ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        SRA H                           ;
                        RR L                            ;
                        LD DE,(PaY)                     ;
                        ADD HL,DE                       ;
                        LD (PmY),HL                     ;
                        CALL TestPm                     ;
                        RET Z                           ;

                        LD HL,(PbX)                     ;
                        LD DE,(PbY)                     ;
                        CALL CalcEdges                  ;
                        LD B,A                          ;
                        LD HL,(PmX)                     ;
                        LD DE,(PmY)                     ;
                        CALL CalcEdges                  ;
                        AND B                           ;
                        JR Z C4a                        ;

                        LD (PbX),HL                     ;
                        LD (PbY),DE                     ;
                        JP C2                           ;

C4a                     LD (PaX),HL                     ;
                        LD (PaY),DE                     ;
                        LD HL,(PbX)                     ;
                        LD DE,(PbY)                     ;
                        LD (PmX),HL                     ;
                        LD (PmY),DE                     ;
                        JP C2                           ;

TestPm                  LD HL,(PmX)                     ;
                        LD DE,(PaX)                     ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        JR NZ TPm1                      ;

                        LD HL,(PmY)                     ;
                        LD DE,(PaY)                     ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        RET Z                           ;

TPm1                    LD HL,(PmX)                     ;
                        LD DE,(PbX)                     ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        RET NZ                          ;

                        LD HL,(PmY)                     ;
                        LD DE,(PbY)                     ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        RET                             ;

; Part of the AnyLine code, which draws lines that aren't horizontal or vertical.

ALOld                   PUSH IX                         ;
                        LD A,(IY+AnySxx)                ;
                        LD (OAxx),A                     ;
                        LD A,(IY+AnySyy)                ;
                        LD (OAyy),A                     ;
                        LD A,(IY+AnyHV)                 ;
                        LD (OAHV),A                     ;
                        LD L,(IY+AnyIXl)                ;
                        LD H,(IY+AnyIXh)                ;
                        PUSH HL                         ;
                        POP IX                          ;
                        LD C,(IY+AnyC1)                 ;
                        LD E,(IY+AnyE1)                 ;
                        LD L,(IY+AnyL1)                 ;
                        EXX                             ;
                        LD B,(IY+AnyB)                  ;
                        LD C,(IY+AnyC)                  ;
                        LD E,(IY+AnyE)                  ;
                        LD L,(IY+AnyL)                  ;
                        LD H,(IY+AnyH)                  ;
                        LD A,(GameAttr)                 ;
                        LD D,A                          ;
                        LD A,(HL)                       ;
OA1                     CPL                             ;
                        OR C                            ;
                        CPL                             ;
                        EXX                             ;
                        EX AF,AF'                       ;
                        LD A,L                          ;
                        SUB E                           ;
                        JR C OA3                        ;

                        LD L,A                          ;
                        EXX                             ;
                        EX AF,AF'                       ;
                        CALL Incxx                      ;
OAHV                    EQU *-2                         ;
                        DJNZ OA1                        ;

                        LD (HL),A                       ;
OA3x                    LD A,C                          ;
                        AND E                           ;
                        JP M OA3a                       ;

                        LD (IX),D                       ;
OA3a                    POP IX                          ;
                        RET                             ;

OA3                     ADD A,C                         ;
                        LD L,A                          ;
                        EX AF,AF'                       ;
                        EXX                             ;
                        CALL Incxx                      ;
OAxx                    EQU *-2                         ;
                        CALL Incxx                      ;
OAyy                    EQU *-2                         ;
                        LD (HL),A                       ;
                        DJNZ OA1                        ;

                        JP OA3x                         ;

; The AnyLine code, which draws lines that aren't likely to be horizontal or vertical.
; Uses good ol'Beshenhams code

; The objects only call this routine if they know the line is not a vert or horiz line, because
; drawing arbitrary lines is so slow.

; This is fundamentally *why* Dark Star doesn't allow the viewpoint to rotate, it just takes
; too damned long to draw sloping lines.

; This code always returns the carry-flag set, it's because it might be the last thing an object
; draw routine calls and the carry-flag means the object is still alive.

AnyLine                 CALL ClipThing                  ; Can we see any part of it?
                        RET C                           ; No, exit

                        ; Surprised this doesn't check to see if the visible part is vertical or horizontal?
                        ; It won't be very often except for short lines, and for short lines it doesn't take long
                        ; to draw them using this algorythmn anyway.

                        LD A,(ctX1)                     ;
                        LD E,A                          ;
                        SRL E                           ;
                        SRL E                           ;
                        SRL E                           ;
                        AND $07                         ;
                        LD L,A                          ;
                        LD H,high BitTab                ;
                        LD C,(HL)                       ;
                        LD H,high DivTab                ;
                        LD A,(ctY1)                     ;
                        LD L,A                          ;
                        LD A,(HL)                       ;
                        LD (ctY1),A                     ;
                        LD D,A                          ;
                        RLCA                            ;
                        RLCA                            ;
                        AND $03                         ;
                        OR $58                          ;
                        LD (IXh),A                      ;
                        LD (IY+AnyIXh),A                ;
                        LD A,D                          ;
                        RLCA                            ;
                        RLCA                            ;
                        AND $E0                         ;
                        OR E                            ;
                        LD (IXl),A                      ;
                        LD (IY+AnyIXl),A                ;
                        LD A,(ctY2)                     ;
                        LD L,A                          ;
                        LD A,(HL)                       ;
                        LD (ctY2),A                     ;
                        LD A,D                          ;
                        AND $07                         ;
                        LD L,A                          ;
                        LD H,high BitTab                ;
                        LD B,(HL)                       ;
                        EXX                             ;
                        PUSH IX                         ;
                        PUSH IY                         ;
                        LD IY,Incyy                     ;
                        LD IX,Incxx                     ;
                        LD DE,(ctY1)                    ;
                        LD HL,(ctY2)                    ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        JP P LineA                      ;

                        mNegHL()                        ;

                        LD IY,Decyy                     ;
LineA                   LD C,L                          ;
                        LD B,H                          ;
                        LD DE,(ctX1)                    ;
                        LD HL,(ctX2)                    ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        JP P LineB                      ;

                        mNegHL()                        ;

                        LD IX,Decxx                     ;
LineB                   LD (sxxVector),IX               ;
                        LD (syyVector),IY               ;
                        OR A                            ;
                        SBC HL,BC                       ;
                        ADD HL,BC                       ;
                        JP M LineC                      ;

                        LD (HorizVector),IX             ;
                        LD E,C                          ;
                        LD D,B                          ;
                        LD C,L                          ;
                        LD B,H                          ;
                        JP LineD                        ;

LineC                   LD (HorizVector),IY             ;
                        EX DE,HL                        ;
                        LD L,C                          ;
                        LD H,B                          ;

LineD                   SRA H                           ;
                        RR L                            ;

                        LD A,C                          ;
                        EXX                             ;
                        POP IY                          ;
                        POP IX                          ;
                        SCF                             ;
                        RET Z                           ;

                        EX AF,AF'                       ;
                        LD H,high YTable                ;
                        LD L,D                          ;
                        LD A,(HL)                       ;
                        ADD A,E                         ;
                        INC H                           ;
                        LD H,(HL)                       ;
                        LD L,A                          ;
                        EX AF,AF'                       ;
                        LD E,B                          ;
                        LD B,A                          ;

                        ; Save everything we need to undraw it again later

                        LD (IY+AnypCode),low ALOld      ;
                        LD (IY+AnypCode+1),high ALOld   ;
                        LD (IY+AnyL),L                  ;
                        LD (IY+AnyH),H                  ;
                        LD (IY+AnyE),E                  ;
                        LD (IY+AnyC),C                  ;
                        LD (IY+AnyB),B                  ;
                        EXX                             ;
                        LD (IY+AnyL1),L                 ;
                        LD (IY+AnyE1),E                 ;
                        LD (IY+AnyC1),C                 ;
                        EXX                             ;

                        LD A,(sxxVector)                ;
                        LD (IY+AnySxx),A                ;
                        LD A,(syyVector)                ;
                        LD (IY+AnySyy),A                ;
                        LD A,(HorizVector)              ;
                        LD (IY+AnyHV),A                 ;

                        LD A,(Colour)                   ;
                        LD D,A                          ;

                        PUSH IX                         ;
                        LD IX,$0000                     ;
IXl                     EQU *-2                         ;
IXh                     EQU *-1                         ;

                        LD A,(HL)                       ;
LineAlg                 OR C                            ;
                        EXX                             ;
                        EX AF,AF'                       ;
                        LD A,L                          ;
                        SUB E                           ;
                        JR C LineAlg1                   ;

                        LD L,A                          ;
                        EXX                             ;
                        EX AF,AF'                       ;
                        CALL Ret                        ;
HorizVector             EQU *-2                         ;

                        DJNZ LineAlg                    ;

                        JP LineX                        ;

LineAlg1                ADD A,C                         ;
                        LD L,A                          ;
                        EXX                             ;
                        EX AF,AF'                       ;
                        CALL Ret                        ;
sxxVector               EQU *-2                         ;
                        CALL Ret                        ;
syyVector               EQU *-2                         ;
                        DJNZ LineAlg                    ;

LineX                   LD (HL),A                       ;
                        LD A,E                          ;
                        AND C                           ;
                        JP M LineXa                     ;

                        LD (IX),D                       ;

LineXa                  POP IX                          ;

                        LD BC,lObjeLine                 ;
                        ADD IY,BC                       ;

                        SCF                             ;
                        RET                             ;

; Page align these next routines, we specify them with a single byte of address (for speed)

                        align 256                       ;

; Move right

Incxx                   RRC C                           ;
                        RET NC                          ;

                        ; Fallen off the RHS of a byte

                        LD (HL),A                       ; Write pixels
                        LD (IX),D                       ; Write attribue
                        INC IXL                         ; Step the pointers
                        INC L                           ;

NoiseFlip3              LD A,$00                        ; Make a noise
                        XOR $F8                         ;
                        LD (NoiseFlip3+1),A             ;
smcNoise3               OUT ($FE),A                     ;

                        LD A,(HL)                       ; Load the existing pixels
                        RET                             ;

; Move left

Decxx                   RLC C                           ;
                        RET NC                          ;

                        ; Fallen off the LHS of a byte

                        LD (HL),A                       ;
                        LD (IX),D                       ;
                        DEC IXL                         ;
                        DEC L                           ;
                        LD A,$00                        ;
NoiseFlip4              XOR $F8                         ;
                        LD (NoiseFlip4),A               ;
smcNoise4               OUT ($FE),A                     ;

                        LD A,(HL)                       ;
                        RET                             ;

; Move down

Incyy                   LD (HL),A                       ;
                        INC H                           ;
                        RRC E                           ;
                        LD A,(HL)                       ;
                        RET NC                          ;

                        ; Moved outside the attribute

                        LD (IX),D                       ;
                        PUSH BC                         ;
                        LD BC,$0020                     ;
                        ADD IX,BC                       ;
                        POP BC                          ;
                        LD A,L                          ;
                        ADD A,$20                       ;
                        LD L,A                          ;
                        LD A,(HL)                       ;
                        RET C                           ;

                        LD A,H                          ;
                        SUB $08                         ;
                        LD H,A                          ;
                        LD A,(HL)                       ;
                        RET                             ;

; Move up

Decyy                   LD (HL),A                       ;
                        DEC H                           ;
                        RLC E                           ;
                        LD A,(HL)                       ;
                        RET NC                          ;

                        ; Moved outside the attribute

                        LD (IX),D                       ;
                        PUSH BC                         ;
                        LD BC,-$20                      ;
                        ADD IX,BC                       ;
                        POP BC                          ;
                        LD A,L                          ;
                        SUB $20                         ;
                        LD L,A                          ;
                        LD A,(HL)                       ;
                        RET C                           ;

                        LD A,H                          ;
                        ADD A,8                         ;
                        LD H,A                          ;
                        LD A,(HL)                       ;
                        RET                             ;

; Page aligned section ends

