; Common values

                        ORG $9200                       ; Game IRQ page
Game_IRQ_Page           ds $101,$90                     ;
Scrolling_Chars         dg ..XXXX..                     ;
                        dg .XX..XX.                     ;
                        dg .XX..XX.                     ;
                        dg ..XXXXX.                     ;
                        dg .....XX.                     ;
                        dg .XX..XX.                     ;
                        dg ..XXXX..                     ;
                        dg ........                     ;
                        dg ..XXXX..                     ;
                        dg .XX..XX.                     ;
                        dg .XX..XX.                     ;
                        dg .XX..XX.                     ;
                        dg .XX..XX.                     ;
                        dg .XX..XX.                     ;
                        dg ..XXXX..                     ;
                        dg ........                     ;
                        dg ...XX...                     ;
                        dg ..XXX...                     ;
                        dg ...XX...                     ;
                        dg ...XX...                     ;
                        dg ...XX...                     ;
                        dg ...XX...                     ;
                        dg .XXXXXX.                     ;
                        dg ........                     ;
                        dg ..XXXX..                     ;
                        dg .XX..XX.                     ;
                        dg .....XX.                     ;
                        dg ..XXXX..                     ;
                        dg .XX.....                     ;
                        dg .XX..XX.                     ;
                        dg .XXXXXX.                     ;
                        dg ........                     ;
                        dg ..XXXX..                     ;
                        dg .XX..XX.                     ;
                        dg .....XX.                     ;
                        dg ...XXX..                     ;
                        dg .....XX.                     ;
                        dg .XX..XX.                     ;
                        dg ..XXXX..                     ;
                        dg ........                     ;
                        dg ...XXX..                     ;
                        dg ..XXXX..                     ;
                        dg .XX.XX..                     ;
                        dg XX..XX..                     ;
                        dg XXXXXXX.                     ;
                        dg ....XX..                     ;
                        dg ...XXXX.                     ;
                        dg ........                     ;
                        dg .XXXXXX.                     ;
                        dg .XX...X.                     ;
                        dg .XX.....                     ;
                        dg .XXXXX..                     ;
                        dg .....XX.                     ;
                        dg .XX..XX.                     ;
                        dg ..XXXX..                     ;
                        dg ........                     ;
                        dg ..XXXX..                     ;
                        dg .XX..XX.                     ;
                        dg .XX.....                     ;
                        dg .XXXXX..                     ;
                        dg .XX..XX.                     ;
                        dg .XX..XX.                     ;
                        dg ..XXXX..                     ;
                        dg ........                     ;
                        dg .XXXXXX.                     ;
                        dg .XX..XX.                     ;
                        dg .....XX.                     ;
                        dg ....XX..                     ;
                        dg ...XX...                     ;
                        dg ...XX...                     ;
                        dg ...XX...                     ;
                        dg ........                     ;
                        dg ..XXXX..                     ;
                        dg .XX..XX.                     ;
                        dg .XX..XX.                     ;
                        dg ..XXXX..                     ;
                        dg .XX..XX.                     ;
                        dg .XX..XX.                     ;
                        dg ..XXXX..                     ;
                        dg ........                     ;
                        dg ..XXXX..                     ;
                        dg .XX..XX.                     ;
                        dg .XX..XX.                     ;
                        dg ..XXXXX.                     ;
                        dg .....XX.                     ;
                        dg .XX..XX.                     ;
                        dg ..XXXX..                     ;
                        dg ........                     ;
cdBlank                 dg ........                     ;
                        dg ........                     ;
                        dg ........                     ;
                        dg ........                     ;
                        dg ........                     ;
                        dg ........                     ;
                        dg ........                     ;
                        dg ........                     ;
                        dg ...X....                     ;
                        dg ..XX....                     ;
                        dg ...X....                     ;
                        dg ...X....                     ;
                        dg ...X....                     ;
                        dg ...X....                     ;
                        dg ..XXX...                     ;
                        dg ........                     ;
;
ReadKey_L               ds 3
ReadKey_R               ds 3
ReadKey_U               ds 3
ReadKey_D               ds 3
ReadKey_Acc             ds 3
ReadKey_Decc            ds 3
ReadKey_Fire            ds 3
                        ds 3

L9381                   dw 0
L9383                   db 0
EnergyBar_CurrPos       db 0
L9385                   dw 0

                        align 256

GameIRQPage             equ *

                        ORG * + (high * )               ;

IRQ_Game                PUSH AF                         ;

                        LD A,(optVarDisplayMode)        ;
                        CP $03                          ;
                        JP Z SimpleIRQ                  ;

                        PUSH BC                         ;
                        PUSH DE                         ;
                        PUSH HL                         ;
                        PUSH IX                         ;

                        EX AF,AF'                       ;
                        PUSH AF                         ;

                        CALL L9515                      ;
                        CALL L964A                      ;
                        LD A,(SecCount)                 ;
                        DEC A                           ;
                        LD (SecCount),A                 ;
                        CP 25                           ;
                        JR Z L94D6                      ;

                        OR A                            ;
                        CALL Z L97B6                    ;
                        LD A,(L9F41)                    ;
                        OR A                            ;
                        JR Z L94BC                      ;

                        DEC A                           ;
                        LD (L9F41),A                    ;
                        CALL Scroll_Time                ;
L94BC                   LD A,(SecCount)                 ;
                        AND $01                         ;
                        JR NZ L94CE                     ;

                        LD A,(EnergyBarPos)             ;
                        LD B,A                          ;

                        LD A,(EnergyBar_CurrPos)        ;
                        CP B                            ;
                        CALL NZ L9E77                   ;

L94CE                   POP AF                          ;
                        EX AF,AF'                       ;
                        POP IX                          ;
                        POP HL                          ;
                        POP DE                          ;
                        POP BC                          ;
                        POP AF                          ;
                        EI                              ;
                        RET                             ;

SimpleIRQ               LD A,(SecCount)                 ;
                        DEC A                           ;
                        LD (SecCount),A                 ;

                        POP AF                          ;
                        EI                              ;
                        RET                             ;


L94D6                   LD A,$00                        ;
                        LD ($0000),A                    ;
L94D9                   EQU *-2                         ;
                        LD ($0000),A                    ;
L94DC                   EQU *-2                         ;
                        JP L94BC                        ;

InitScore               LD HL,$0000                     ;
                        LD (Score),HL                   ;
                        LD (L9385),HL                   ;

                        LD HL,DigitsValueBuff+3         ;
                        LD (L9567),HL                   ;
                        LD A,$09                        ;
                        LD (L95B5),A                    ;
                        LD A,$05                        ;
                        LD (L956B),A                    ;
                        LD A,(optVarDisplayMode)        ;
                        LD HL,$50DB                     ;
                        OR A                            ;
                        JR Z L9506                      ;

                        LD HL,$50BA                     ;
L9506                   LD (Score_Pos),HL               ;

                        LD HL,InitSomething3            ;
                        LD DE,DigitsValueBuff           ;
                        LD BC,$000F                     ;
                        LDIR                            ;
                        RET                             ;

L9515                   LD A,(SecCount)                 ;
                        BIT 0,A                         ;
                        RET Z                           ;

                        LD A,(L95B5)                    ;
                        DEC A                           ;
                        JR NZ L9595                     ;

                        LD HL,(L9385)                   ;
                        LD DE,(Score)                   ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        RET Z                           ;

                        EX DE,HL                        ;
                        LD (L9385),HL                   ;
                        LD IX,DigitsValueBuff           ;
                        LD B,5                          ;
                        LD A,(optVarDisplayMode)        ;
                        LD DE,$50DA                     ;
                        OR A                            ;
                        JR Z L9542                      ;

                        LD DE,$50B9                     ;
L9542                   CALL L95EF                      ;
                        DEC B                           ;
                        INC E                           ;
                        INC IX                          ;
                        INC IX                          ;
                        INC IX                          ;
                        OR A                            ;
                        JR Z L9542                      ;

L9550                   ADD A,A                         ;
                        ADD A,A                         ;
                        ADD A,A                         ;
                        ADD A,$09                       ;
                        CP (IX-3)                       ;
                        JR NZ L956C                     ;

                        DEC B                           ;
                        INC E                           ;
                        CALL L95EF                      ;
                        INC IX                          ;
                        INC IX                          ;
                        INC IX                          ;
                        JR L9550                        ;

L9567                   dw 0                            ;
Score_Pos               dw 0                            ;
L956B                   db 0                            ;

L956C                   LD (L9567),IX                   ;
                        LD (Score_Pos),DE               ;
                        PUSH AF                         ;
                        LD A,B                          ;
                        INC A                           ;
                        LD (L956B),A                    ;
                        POP AF                          ;
                        JR L9582                        ;

L957D                   ADD A,A                         ;
                        ADD A,A                         ;
                        ADD A,A                         ;
                        ADD A,$09                       ;
L9582                   LD (IX-3),A                     ;
                        LD (IX-1),A                     ;
                        CALL L95EF                      ;
                        INC IX                          ;
                        INC IX                          ;
                        INC IX                          ;
                        DJNZ L957D                      ;

                        LD A,$08                        ;
L9595                   LD (L95B5),A                    ;
                        SUB $09                         ;
                        NEG                             ;
                        LD (L95C4),A                    ;
                        LD A,(L956B)                    ;
                        LD B,A                          ;
                        LD DE,(Score_Pos)               ;
                        LD IX,(L9567)                   ;
                        LD H,high Scrolling_Chars       ;
L95AD                   PUSH BC                         ;
                        LD L,(IX-2)                     ;
                        INC (IX-2)                      ;
                        LD A,$00                        ;
L95B5                   EQU *-1                         ;
                        DEC A                           ;
                        LD B,A                          ;
                        JR Z L95C0                      ;

L95BA                   LD A,(HL)                       ;
                        LD (DE),A                       ;
                        INC L                           ;
                        INC D                           ;
                        DJNZ L95BA                      ;

L95C0                   LD L,(IX-1)                     ;
                        LD A,$00                        ;
L95C4                   EQU *-1                         ;
                        OR A                            ;
                        JR Z L95CF                      ;

                        LD B,A                          ;
L95C9                   LD A,(HL)                       ;
                        LD (DE),A                       ;
                        INC L                           ;
                        INC D                           ;
                        DJNZ L95C9                      ;

L95CF                   INC IX                          ;
                        INC IX                          ;
                        INC IX                          ;
                        POP BC                          ;
                        LD A,D                          ;
                        SUB $08                         ;
                        LD D,A                          ;
                        INC E                           ;
                        DJNZ L95AD                      ;

                        LD A,(L95B5)                    ;
                        DEC A                           ;
                        RET NZ                          ;

                        LD HL,DigitsValueBuff           ;
                        LD B,5                          ;
L95E7                   LD A,(HL)                       ;
                        INC HL                          ;
                        LD (HL),A                       ;
                        INC HL                          ;
                        INC HL                          ;
                        DJNZ L95E7                      ;

                        RET                             ;

L95EF                   XOR A                           ;
                        ADD HL,HL                       ;
                        RLA                             ;
                        ADD HL,HL                       ;
                        RLA                             ;
                        ADD HL,HL                       ;
                        RLA                             ;
                        ADD HL,HL                       ;
                        RLA                             ;
                        RET                             ;

L95F9                   LD HL,(L9F63)                   ;
                        LD A,(HL)                       ;
                        INC HL                          ;
                        LD (L9F63),HL                   ;
                        INC A                           ;
                        LD (L9F62),A                    ;
                        JP Z L970D                      ;

                        DEC A                           ;
                        JR Z L9643                      ;

                        CP $20                          ;
                        JR NC L9626                     ;

                        LD (L9F65),A                    ;
                        LD A,$03                        ;
                        LD (PixelsToNextChar),A         ;
                        LD HL,SLBuff                    ;
                        LD DE,SLBuff+1                  ;
                        LD BC,$0007                     ;
                        LD (HL),$00                     ;
                        LDIR                            ;
                        JR L965B                        ;

L9626                   LD L,A                          ;
                        LD H,high CharSetWidths         ;
                        LD A,(HL)                       ;
                        INC A                           ;
                        SRA A                           ;
                        LD (PixelsToNextChar),A         ;
                        LD H,0                          ;
                        ADD HL,HL                       ;
                        ADD HL,HL                       ;
                        ADD HL,HL                       ;
                        LD A,high CharSetPixels-1       ;
                        ADD A,H                         ;
                        LD H,A                          ;
                        LD DE,SLBuff                    ;
                        LD BC,$0008                     ;
                        LDIR                            ;
                        JR L965B                        ;

L9643                   LD A,$7F                        ;
                        LD (PixelsToNextChar),A         ;
                        JR L965B                        ;

L964A                   LD A,(L9F62)                    ;
                        OR A                            ;
                        JP Z L970D                      ;

                        LD A,(PixelsToNextChar)         ;
                        OR A                            ;
                        JR Z L95F9                      ;

                        DEC A                           ;
                        LD (PixelsToNextChar),A         ;

L965B                   LD A,(L9F66)                    ;
                        DEC A                           ;
                        LD (L9F66),A                    ;
                        AND $03                         ;
                        CALL Z L96FD                    ;

                        LD HL,SLBuff                    ;
                        SLA (HL)                        ;
                        EX AF,AF'                       ;
                        SLA (HL)                        ;
                        EX AF,AF'                       ;
                        LD HL,$50FF                     ;
                        CALL ShiftLine                  ;

                        LD HL,SLBuff+1                  ;
                        SLA (HL)                        ;
                        EX AF,AF'                       ;
                        SLA (HL)                        ;
                        EX AF,AF'                       ;
                        LD HL,$51FF                     ;
                        CALL ShiftLine                  ;

                        LD HL,SLBuff+2                  ;
                        SLA (HL)                        ;
                        EX AF,AF'                       ;
                        SLA (HL)                        ;
                        EX AF,AF'                       ;
                        LD HL,$52FF                     ;
                        CALL ShiftLine                  ;

                        LD HL,SLBuff+3                  ;
                        SLA (HL)                        ;
                        EX AF,AF'                       ;
                        SLA (HL)                        ;
                        EX AF,AF'                       ;
                        LD HL,$53FF                     ;
                        CALL ShiftLine                  ;

                        LD HL,SLBuff+4                  ;
                        SLA (HL)                        ;
                        EX AF,AF'                       ;
                        SLA (HL)                        ;
                        EX AF,AF'                       ;
                        LD HL,$54FF                     ;
                        CALL ShiftLine                  ;

                        LD HL,SLBuff+5                  ;
                        SLA (HL)                        ;
                        EX AF,AF'                       ;
                        SLA (HL)                        ;
                        EX AF,AF'                       ;
                        LD HL,$55FF                     ;
                        CALL ShiftLine                  ;

                        LD HL,SLBuff+6                  ;
                        SLA (HL)                        ;
                        EX AF,AF'                       ;
                        SLA (HL)                        ;
                        EX AF,AF'                       ;
                        LD HL,$56FF                     ;
                        CALL ShiftLine                  ;

                        LD HL,SLBuff+7                  ;
                        SLA (HL)                        ;
                        EX AF,AF'                       ;
                        SLA (HL)                        ;
                        EX AF,AF'                       ;
                        LD HL,$57FF                     ;

                        ; Shift a pixel-line to the left

ShiftLine               LD B,8                          ;

ShiftLineLp             RL (HL)                         ;
                        EX AF,AF'                       ;
                        RL (HL)                         ;
                        EX AF,AF'                       ;
                        DEC L                           ;
                        RL (HL)                         ;
                        EX AF,AF'                       ;
                        RL (HL)                         ;
                        EX AF,AF'                       ;
                        DEC L                           ;
                        RL (HL)                         ;
                        EX AF,AF'                       ;
                        RL (HL)                         ;
                        EX AF,AF'                       ;
                        DEC L                           ;
                        RL (HL)                         ;
                        EX AF,AF'                       ;
                        RL (HL)                         ;
                        EX AF,AF'                       ;
                        DEC L                           ;

                        DJNZ ShiftLineLp                ;

                        RET                             ;

L96FD                   LD HL,$5AE1                     ;
                        LD DE,$5AE0                     ;
                        LD BC,$001F                     ;
                        LDIR                            ;

                        LD A,(L9F65)                    ;
                        LD (DE),A                       ;
                        RET                             ;

L970D                   LD IX,$0000                     ;
L970F                   EQU *-2                         ;
                        LD A,(IX+2)                     ;
                        OR A                            ;
                        RET Z                           ;

                        LD A,$01                        ;
                        LD (L9F62),A                    ;
                        LD L,(IX )                      ;
                        LD H,(IX +1)                    ;
                        LD (IX+2),$00                   ;
                        LD (L9F63),HL                   ;
                        PUSH IX                         ;
                        POP HL                          ;
                        INC HL                          ;
                        INC HL                          ;
                        INC HL                          ;
                        LD DE,L97B6                     ;
                        LD (L970F),HL                   ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        RET NZ                          ;

                        LD HL,ScrollBuff                ;
                        LD (L970F),HL                   ;
                        RET                             ;

; Scroll a message across the bottom of the screen

ScrollMessage           LD A,(optVarDisplayMode)        ;
                        CP $03                          ;
                        RET Z                           ;

                        PUSH IX                         ;
                        DI                              ;
                        LD IX,$0000                     ;
L974A                   EQU *-2                         ;
                        LD A,(IX +2)                     ;
                        OR A                            ;
                        JR NZ L9773                     ;

                        LD (IX ),L                       ;
                        LD (IX +1),H                     ;
                        LD (IX +2),$01                   ;

                        PUSH IX                         ;
                        POP HL                          ;

                        INC HL                          ;
                        INC HL                          ;
                        INC HL                          ;

                        LD (L974A),HL                   ;

                        LD DE,L97B6                     ;
                        OR A                            ;
                        SBC HL,DE                       ;
                        JR NZ L9773                     ;

                        LD HL,ScrollBuff                ;
                        LD (L974A),HL                   ;

L9773                   POP IX                          ;
                        EI                              ;
                        RET                             ;

L9777                   XOR A                           ;
                        LD (L9F62),A                    ;
                        LD (PixelsToNextChar),A         ;
                        LD (L9F66),A                    ;

                        LD HL,ScrollBuff                ;
                        LD (L974A),HL                   ;
                        LD (L970F),HL                   ;

                        LD HL,ScrollBuff                ;
                        LD DE,ScrollBuff+1              ;
                        LD BC,$001D                     ;
                        LD (HL),$00                     ;
                        LDIR                            ;
                        RET                             ;

ScrollBuff              DEFS 30,0                       ;

L97B6                   LD A,$08                        ;
                        LD (L9F41),A                    ;

                        LD A,$32                        ;
                        LD (SecCount),A                 ;

                        LD A,$47                        ;
L97C1                   EQU *-1                         ;
                        LD ($0000),A                    ;
L97C3                   EQU *-2                         ;
                        LD ($0000),A                    ;
L97C6                   EQU *-2                         ;

                        CALL L97D0                      ;
                        LD A,B                          ;
                        LD (L9F42),A                    ;
                        RET                             ;

L97D0                   LD DE,Clock_Buff+24             ;
                        LD HL,Clock_Buff                ;
                        LD B,1                          ;
                        CALL L97F1                      ;
                        RET C                           ;

                        CALL L9802                      ;
                        RET C                           ;

                        CALL L97F1                      ;
                        RET C                           ;

                        CALL L9802                      ;
                        RET C                           ;

                        CALL L97F1                      ;
                        RET C                           ;

                        CALL L97F1                      ;
                        DEC B                           ;
                        RET                             ;

L97F1                   LD A,(DE)                       ;
                        INC A                           ;
                        LD (DE),A                       ;
                        CP $0A                          ;
                        RET C                           ;

                        LD (HL),low Scrolling_Chars     ;
                        INC HL                          ;
                        LD (HL),high Scrolling_Chars    ;
                        INC HL                          ;
                        XOR A                           ;
                        LD (DE),A                       ;
                        INC B                           ;
                        INC DE                          ;
                        RET                             ;

L9802                   LD A,(DE)                       ;
                        INC A                           ;
                        LD (DE),A                       ;
                        CP $06                          ;
                        RET C                           ;

                        LD (HL),low Scrolling_Chars     ;
                        INC HL                          ;
                        LD (HL),high Scrolling_Chars    ;
                        INC HL                          ;
                        XOR A                           ;
                        LD (DE),A                       ;
                        INC B                           ;
                        INC DE                          ;
                        RET                             ;

Scroll_Time             LD IX,Clock_Buff                ;
                        LD A,(L9F42)                    ;
                        LD B,A                          ;
L981B                   LD E,(IX)                       ;
                        LD D,(IX +1)                    ;
                        LD L,(IX +12)                   ;
                        LD H,(IX +13)                   ;
                        LD C,$08                        ;
L9829                   LD A,(DE)                       ;
                        INC DE                          ;
                        LD (HL),A                       ;
                        INC H                           ;
                        DEC C                           ;
                        JR NZ L9829                     ;

                        INC (IX)                        ;
                        INC IX                          ;
                        INC IX                          ;
                        DJNZ L981B                      ;

                        RET                             ;

; Setup the IRQ

Init_Game_IRQ           LD HL,Game_IRQ_Page             ;
                        LD B,0                          ;
                        LD A,high GameIRQPage           ;
IGI_Lp                  LD (HL),A                       ;
                        INC HL                          ;
                        DJNZ IGI_Lp                     ;
                        LD (HL),A                       ;

                        LD A,$01                        ;
                        LD (SecCount),A                 ;

                        XOR A                           ;
                        LD (L9F62),A                    ;

                        LD A,high Game_IRQ_Page         ;
                        LD I,A                          ;

                        IM 2                            ;
                        RET                             ;

;

InitClock               LD HL,DigitsValueBuff_2         ;
                        LD DE,$580E                     ;
                        LD BC,$5811                     ;

                        LD A,(optVarDisplayMode)        ;
                        OR A                            ;
                        LD A,$47                        ;
                        JR Z L9C50                      ;

                        LD A,$07                        ;
                        LD HL,Clock_Defn                ;
                        LD DE,$5AA3                     ;
                        LD BC,$5AA6                     ;

L9C50                   LD (L94D9),DE                   ;
                        LD (L97C3),DE                   ;
                        LD (L94DC),BC                   ;
                        LD (L97C6),BC                   ;
                        LD (L97C1),A                    ;

                        LD DE,Clock_Buff                ;
                        LD BC,$001E                     ;
                        LDIR                            ;

                        LD A,(optVarDisplayMode)        ;
                        OR A                            ;
                        LD A,$1C                        ;
                        JR Z Write2ColonsNorm           ;

                        ; Write then at the alternate posn

                        LD HL,$52A3                     ;
                        CALL WriteColon                 ;

                        LD HL,$52A6                     ;

WriteColon              LD (HL),A                       ;
                        INC H                           ;
                        LD (HL),A                       ;
                        INC H                           ;

                        INC H                           ;
                        LD (HL),A                       ;
                        INC H                           ;
                        LD (HL),A                       ;
                        RET                             ;

Write2ColonsNorm        LD HL,$420E                     ;
                        CALL WriteColon                 ;
                        LD HL,$4211                     ;
                        JR WriteColon                   ;

;

; Clock definition 59:59:59
Clock_Defn              DEFW cdBlank,cdBlank,cdBlank,cdBlank,cdBlank,cdBlank
                        defb $A8,$50
                        defb $A7,$50
                        DEFB $A5,$50
                        defb $A4,$50
                        defb $A2,$50
                        defb $A1,$50
                        DEFB $09,$05,$09,$05,$09,$09

DigitsValueBuff_2       DEFB $59,$93,$59,$93,$59,$93,$59,$93
                        DEFB $59,$93,$59,$93,$13,$40,$12,$40
                        DEFB $10,$40,$0F,$40,$0D,$40,$0C,$40
                        DEFB $09,$05,$09,$05,$09,$09

SecCount                DEFB $01                        ;
L9F41                   DEFB $01                        ;
L9F42                   DEFB $01                        ;
Clock_Buff              ds 30,0
PixelsToNextChar        DEFB $00                        ;
L9F62                   DEFB $00                        ;
L9F63                   DEFB $00,$00                    ;
L9F65                   DEFB $45                        ;
L9F66                   DEFB $00                        ;

SLBuff                  DS 8

DigitsValueBuff         DEFB $59,$59,$59                ;
                        DEFB $59,$59,$59,$59,$59,$59,$59,$59;
                        DEFB $59,$09,$09,$09            ;

Score                   DEFW 0

EnergyBarPos            DEFB 0


